public class Sorter {
    public static void main(String[] args) {
        System.out.println("Selectionsort");
        int[] a = {9,4,2,6,7};
        ausgabe(a);
        int[] b = selsortStep(a);
        ausgabe(b);

        System.out.println("Bubblesort");
        int[] c = {9,4,2,6,7};
        ausgabe(c);
        int[] d = bubbleStep(c);
        ausgabe(d);
    }

    public static void ausgabe(int[] a) {
        System.out.println("Array: ");
        for(int i = 0; i < a.length-1; i++) {
            System.out.print(""+a[i]+", ");
        }
        System.out.println(""+a[a.length-1]);
    }

    public static int[] selsort(int[] a) {
        for(int i = 0; i < a.length; i++) {
            for(int j = i; j<a.length; j++) {
                if(a[j] < a[i]) {
                    int h = a[i];
                    a[i] = a[j];
                    a[j] = h;
                }
            }
        }
        return a;
    }

    public static String arrayToString(int[] a) {
        String result = "";
        for(int i = 0; i < a.length; i++) {
            result += "a["+i+"]: "+a[i]+" ";
            result += (i==(a.length-1))?"":" | ";
        }
        return result;
    }

    public static String arrayToString(int[] a,int m1, int m2) {
        String result = "";
        for(int i = 0; i < a.length; i++) {
            if(i == m1 || i == m2) {
                result += "a["+i+"]:#"+a[i]+"#";
                result += (i==(a.length-1))?"":" | ";
            } else {
                result += "a["+i+"]: "+a[i]+" ";
                result += (i==(a.length-1))?"":" | ";
            }
        }
        return result;
    }

    public static String arrayToString(int[] a,int m1) {
        String result = "";
        for(int i = 0; i < a.length; i++) {
            if(i == m1 || i == (m1+1)) {
                result += "a["+i+"]:#"+a[i]+"#";
                result += (i==(a.length-1))?"":" | ";
            } else {
                result += "a["+i+"]: "+a[i]+" ";
                result += (i==(a.length-1))?"":" | ";
            }
        }
        return result;
    }

    public static int[] selsortStep(int[] a) {
        System.out.println(arrayToString(a));
        for(int i = 0; i < a.length; i++) {
            for(int j = i; j<a.length; j++) {
                System.out.println(arrayToString(a,i,j) + " | i:"+i+" | j:"+j);
                if(a[j] < a[i]) {
                    int h = a[i];
                    a[i] = a[j];
                    a[j] = h;
                    System.out.println(arrayToString(a,i,j) + " | i:"+i+" | j:"+j+" *Tausch*");
                }
            }
        }
        return a;
    }

    public static int[] bubbleStep(int[] a) {
        System.out.println(arrayToString(a));
        for(int i = a.length-1; i >= 0; i--) {
            for(int j = 0; j<i; j++) {
                System.out.println(arrayToString(a,j) + " | i:"+i+" | j:"+j);
                if(a[j] > a[j+1]) {
                    int h = a[j];
                    a[j] = a[j+1];
                    a[j+1] = h;
                    System.out.println(arrayToString(a,j) + " | i:"+i+" | j:"+j+" *Tausch*");
                }
            }
        }
        return a;
    }

}
